/*****************************************************************************
*
*   INTERFAZ E IMPLEMENTACION DEL MODULO: AnaLogs.c
*
*   VERSION: 1.0
*
*   LUGAR Y FECHA DE CREACION: Santiago de Cali, Octubre de 2003 V. 1.0
*
*   Descripcin: Programa que analisa los logs generados en el archivo:
*                c:\AnaLogs\logs.html
*
*   Requerimientos: Este programa lee un archivo logs.html desde el
*                   directorio: c:\AnaLogs. Luego se eliminan las etiquetas
*                   de HTML y con los registros que quedan se crea un nuevo
*                   archivo llamado Logs.txt, donde cada fila es un LOG.
*                   Con este archivo el AnaLogs hace su analisis.
*
*****************************************************************************/

/*___________________________________________________________________________*

	 Archivos de interfaz de librerias estandar y otros modulos
*___________________________________________________________________________*/
#include  <stdio.h>
#include  <conio.h>
#include <stdlib.h>
#include <string.h>
/*___________________________________________________________________________*

		 Declaracion de Constantes y Macros, publicas
*___________________________________________________________________________*/
#define Esc 27
#define Tab  9
/*___________________________________________________________________________*

	 Declaracion de Estructuras y Redefiniciones de Tipo, publicas
*___________________________________________________________________________*/
struct Log
{
	char Mes[4];
	char Dia[3];
	char Hora[3];
	char Min[3];
	char Seg[3];
	char Servidor[23];
	char ID[36];
	char Accion[40];
	char User[10];
};

/*___________________________________________________________________________*

		       Definicion de Variables Publicas
*___________________________________________________________________________*/
typedef struct Log elemento;
/*___________________________________________________________________________*

	 Archivos de interfaz de librerias estandar y otros modulos
*___________________________________________________________________________*/
#include "c:\analogs\lista_ap.h"
lista fecha;
/*___________________________________________________________________________*

		       Prototipos de Funciones Publicas
*___________________________________________________________________________*/
void presentacion(void);
void cargar_archivos(void);
void analisis_logs(void);
void consola_administracion(void);
void salir(void);
/*___________________________________________________________________________*

		       Prototipos de Funciones Privadas
*___________________________________________________________________________*/

/*___________________________________________________________________________*

		    Implementacion de Funciones Publicas
*___________________________________________________________________________*/
void main(void)
{
	presentacion();
	printf("Espere, procesando los Logs.");
	cargar_archivos();
	fecha = inic_lista();
	analisis_logs();
}

void presentacion(void)
{
	clrscr();
	textbackground(LIGHTBLUE);
	window( 10, 5, 70, 20);
	clrscr();
	textcolor(YELLOW);
	gotoxy(14,3);
	printf("            AnaLogs 1.0");
	gotoxy(14,5);
	printf("        HECTOR FABIO PANESSO");
	gotoxy(14,6);
	printf("       CARLOS ALBERTO MURILLO");
	gotoxy(14,9);
	printf(" ESTE PROGRAMA ANALIZA LOS LOGS");
	gotoxy(14,10);
	printf("GENERADOS EN EL ARCHIVO logs.html");
	gotoxy(14,12);
	printf("            BIENVENIDO");
	gotoxy(14,14);
	printf("          OCTUBRE DE 2003");
	gotoxy(22,16);
	printf("      DIGITE UNA TECLA PARA CONTINUAR...");
	getch();
	textbackground(BLACK);
	textcolor(WHITE);
	window(1,1,80,25);
	clrscr();
}

void cargar_archivos(void)
{

	FILE *archivoHTML;
	FILE *archivoTXT;
	FILE *archivoTXT2;
	FILE *archivoTXT3;
	FILE *archivoTXT4;
	int i, opcion, tecla, copiar, num1, num2, num3;
	char caracter, charAnt, charPen, charAnte, charAnteAnte;
	char cadena1[2], cadena2[2], cadena3[2], cadena4[2];

	if ( (archivoHTML=fopen("d:\\tc\\tmp\\logs~1.html","rt")) == NULL )
	{
		printf("\n\n\nERROR!!! EL ARCHIVO NO EXISTE\n");
		printf("\nDIGITE UNA TECLA PARA TERMINAR...\n");
		getch();
		fclose(archivoHTML);
		salir();
		return;
	}

	if ( (archivoTXT2=fopen("d:\\tc\\tmp\\logs2.txt","wt")) == NULL )
	{
		printf("\n\n\nERROR!!! EL ARCHIVO NO PUDO SER CREADO\n");
		printf("\nDIGITE UNA TECLA PARA TERMINAR...\n");
		getch();
		fclose(archivoTXT2);
		salir();
		return;
	}

	fseek(archivoHTML,0L,SEEK_END);
	if ( ftell(archivoHTML)==0 )
	{
		printf("\n\n\nERROR! EL ARCHIVO ESTA VACIO\n");
		printf("\nDIGITE UNA TECLA PARA TERMINAR...\n");
		getch();
		fclose(archivoHTML);
		salir();
	}

	rewind(archivoHTML);
	copiar=0;
	while ( !feof(archivoHTML) )
	{
		caracter=fgetc(archivoHTML);
		if(caracter=='<')
		{
			caracter=fgetc(archivoHTML);
			if(caracter=='s')
				caracter=fgetc(archivoHTML);
					if(caracter=='p')
					{
						copiar=1;
						fputc('\n', archivoTXT2);
					}
					else
						copiar=0;
			while(caracter!='>')
				caracter=fgetc(archivoHTML);
		}
		else
		{
			if(copiar==1)
				fputc(caracter, archivoTXT2);
		}
	}
	fclose(archivoHTML);
	fclose(archivoTXT2);

	if ( (archivoTXT=fopen("d:\\tc\\tmp\\logs3.txt","wt")) == NULL )
	{
		printf("\n\n\nERROR!!! EL ARCHIVO NO PUDO SER CREADO\n");
		printf("\nDIGITE UNA TECLA PARA TERMINAR...\n");
		getch();
		fclose(archivoTXT);
		salir();
		return;
	}

	if ( (archivoTXT2=fopen("d:\\tc\\tmp\\logs2.txt","rt")) == NULL )
	{
		printf("\n\n\nERROR!!! EL ARCHIVO NO PUDO SER ABIERTO\n");
		printf("\nDIGITE UNA TECLA PARA TERMINAR...\n");
		getch();
		fclose(archivoTXT2);
		salir();
		return;
	}

	fseek(archivoTXT2,0L,SEEK_END);
	if ( ftell(archivoTXT2)==0 )
	{
		printf("\n\n\nERROR! EL ARCHIVO ESTA VACIO\n");
		printf("\nDIGITE UNA TECLA PARA TERMINAR...\n");
		getch();
		fclose(archivoTXT2);
		salir();
	}
	rewind(archivoTXT2);

	while ( !feof(archivoTXT2) )
	{
		caracter=fgetc(archivoTXT2);
		if(caracter!='\n')
			fputc(caracter, archivoTXT);
	}
	fclose(archivoTXT2);
	fclose(archivoTXT);

	if ( (archivoTXT4=fopen("d:\\tc\\tmp\\logs4.txt","wt")) == NULL )
	{
		printf("\n\n\nERROR!!! EL ARCHIVO NO PUDO SER ABIERTO\n");
		printf("\nDIGITE UNA TECLA PARA TERMINAR...\n");
		getch();
		fclose(archivoTXT4);
		salir();
		return;
	}

	if ( (archivoTXT3=fopen("d:\\tc\\tmp\\logs3.txt","rt")) == NULL )
	{
		printf("\n\n\nERROR!!! EL ARCHIVO NO PUDO SER ABIERTO\n");
		printf("\nDIGITE UNA TECLA PARA TERMINAR...\n");
		getch();
		fclose(archivoTXT3);
		salir();
		return;
	}

	fseek(archivoTXT3,0L,SEEK_END);
	if ( ftell(archivoTXT3)==0 )
	{
		printf("\n\n\nERROR! EL ARCHIVO ESTA VACIO\n");
		printf("\nDIGITE UNA TECLA PARA TERMINAR...\n");
		getch();
		fclose(archivoTXT3);
		salir();
	}
	rewind(archivoTXT3);

	while ( !feof(archivoTXT3) )
	{
		caracter=fgetc(archivoTXT3);
		charAnteAnte=charAnte;
		charAnte=charPen;
		charPen=charAnt;
		charAnt=caracter;

		if( (charAnteAnte=='.') && (charPen>=48 && charPen<=59) && (charAnte>=48 && charAnte<59) && (charAnt!='.') && !(charAnt>=48 && charAnt<=59) )
		{
			if(charAnt==']')
			{
				fputc(caracter, archivoTXT4);
				fputc('\n', archivoTXT4);
			}
			else
			{
				fputc('\n', archivoTXT4);
				fputc(caracter, archivoTXT4);
			}
		}
		else
		{

			if( (charAnte=='.') && (charPen>=48 && charPen<=59) && (charAnt!='.') && !(charAnt>=48 && charAnt<=59) )
			{
				if(charAnt==']')
				{
					fputc(caracter, archivoTXT4);
					fputc('\n', archivoTXT4);
				}
				else
				{
					fputc('\n', archivoTXT4);
					fputc(caracter, archivoTXT4);
				}
			}
			else
				fputc(caracter, archivoTXT4);
		}
	}
	fclose(archivoTXT3);
	fclose(archivoTXT4);

	if ( (archivoTXT=fopen("d:\\tc\\tmp\\logs.txt","wt")) == NULL )
	{
		printf("\n\n\nERROR!!! EL ARCHIVO NO PUDO SER ABIERTO\n");
		printf("\nDIGITE UNA TECLA PARA TERMINAR...\n");
		getch();
		fclose(archivoTXT);
		salir();
		return;
	}

	if ( (archivoTXT4=fopen("d:\\tc\\tmp\\logs4.txt","rt")) == NULL )
	{
		printf("\n\n\nERROR!!! EL ARCHIVO NO PUDO SER ABIERTO\n");
		printf("\nDIGITE UNA TECLA PARA TERMINAR...\n");
		getch();
		fclose(archivoTXT4);
		salir();
		return;
	}

	fseek(archivoTXT4,0L,SEEK_END);
	if ( ftell(archivoTXT3)==0 )
	{
		printf("\n\n\nERROR! EL ARCHIVO ESTA VACIO\n");
		printf("\nDIGITE UNA TECLA PARA TERMINAR...\n");
		getch();
		fclose(archivoTXT4);
		salir();
	}
	rewind(archivoTXT4);

	while ( !feof(archivoTXT4) )
	{
		caracter=fgetc(archivoTXT4);
		if(caracter>=65 && caracter<=90)
		{
			while ( caracter!='\n' && !feof(archivoTXT4) )
			{
				fputc(caracter, archivoTXT);
				caracter=fgetc(archivoTXT4);
			}
			fputc(caracter, archivoTXT);
		}
		else
		{
			while ( caracter!='\n'&& !feof(archivoTXT4) )
				caracter=fgetc(archivoTXT4);
		}

	}
	clrscr();

}

void analisis_logs(void)
{

	struct Log Log;
	struct Log2 Log2;
	FILE *archivoTXT;
	int num, j, pos=0, FechaValida=1, ServidorValido=1, UserValido;
	char caracter;

	if ( (archivoTXT=fopen("d:\\tc\\tmp\\logs.txt","rt")) == NULL )
	{
		printf("\n\n\nERROR!!! EL ARCHIVO NO PUDO SER ABIERTO\n");
		printf("\nDIGITE UNA TECLA PARA TERMINAR...\n");
		getch();
		fclose(archivoTXT);
		salir();
		return;
	}

	fseek(archivoTXT,0L,SEEK_END);
	if ( ftell(archivoTXT)==0 )
	{
		printf("\n\n\nERROR! EL ARCHIVO ESTA VACIO\n");
		printf("\nDIGITE UNA TECLA PARA TERMINAR...\n");
		getch();
		fclose(archivoTXT);
		salir();
	}

	rewind(archivoTXT);

	while ( !feof(archivoTXT) )
	{
		caracter=fgetc(archivoTXT);
		if(caracter=='\n')
		{
			caracter=fgetc(archivoTXT);
			if(caracter>=65 && caracter<=90)
			{
				j=0;
				while(j<3)
				{
					Log.Mes[j]=caracter;
					caracter=fgetc(archivoTXT);
					j++;
				}
				Log.Mes[3]='\0';
				j=0;
				if(caracter>=65 && caracter<=90)
				{
					FechaValida=0;
					pos--;
				}
				while(j<2)
				{
					Log.Dia[j]=caracter;
					caracter=fgetc(archivoTXT);
					j++;
				}
				Log.Dia[2]='\0';
				caracter=fgetc(archivoTXT);
				j=0;
				while(j<2)
				{
					Log.Hora[j]=caracter;
					caracter=fgetc(archivoTXT);
					j++;
				}
				Log.Hora[2]='\0';
				caracter=fgetc(archivoTXT);
				j=0;
				while(j<2)
				{
					Log.Min[j]=caracter;
					caracter=fgetc(archivoTXT);
					j++;
				}
				Log.Min[2]='\0';
				caracter=fgetc(archivoTXT);
				j=0;
				while(j<2)
				{
					Log.Seg[j]=caracter;
					caracter=fgetc(archivoTXT);
					j++;
				}
			}
			Log.Seg[2]='\0';
			j=0;
			while(j<17)
			{
				caracter=fgetc(archivoTXT);
				if((caracter>=97 && caracter<=122) || (caracter>=65 && caracter<=90) || caracter=='.' || caracter==' ')
					Log.Servidor[j]=caracter;
				else
				{
					ServidorValido=0;
					pos--;
					break;
				}
				j++;
			}
			Log.Servidor[17]='\0';
			caracter=fgetc(archivoTXT);
			while(caracter!=':')
				caracter=fgetc(archivoTXT);
			j=0;
			while(j<5)
			{
				caracter=fgetc(archivoTXT);
				j++;
			}
			j=0;
			while(j<6)
			{
				caracter=fgetc(archivoTXT);
				Log.ID[j]=caracter;
				j++;
			}
			Log.ID[6]='\0';
			caracter=fgetc(archivoTXT);
			while(caracter!=']')
				caracter=fgetc(archivoTXT);
			caracter=fgetc(archivoTXT);
			caracter=fgetc(archivoTXT);
			if(caracter=='i')
				strcpy(Log.Accion, "imap serviceinit");
			if(caracter=='A')
				strcpy(Log.Accion, "Authenticateduser");
			if(caracter=='C')
				strcpy(Log.Accion, "Connectionreset by peer");
			j=0;
			if(caracter=='L')
			{
				j=0;
				while(j<3)
				{
					caracter=fgetc(archivoTXT);
					j++;
				}
				if(caracter=='o')
				{
					strcpy(Log.Accion, "Logoutuser");
					j=-1;
				}
				else
				{
					strcpy(Log.Accion, "Loginuser");
					j=0;
				}
				while(j<6)
				{
					caracter=fgetc(archivoTXT);
					j++;
				}
				j=0;
				while(caracter!=' ')
				{
					caracter=fgetc(archivoTXT);
					if((caracter>=97 && caracter<=122) || (caracter>=65 && caracter<=90) || caracter==' ')
						Log.User[j]=caracter;
					else
					{
						UserValido=0;
						break;
					}
					j++;
				}
				j--;
			}
			if(!UserValido)
				j=0;
			Log.User[j]='\0';
			if((pos<400) && FechaValida && ServidorValido)
				fecha = anx_lista(fecha, Log);
			if(pos==117)
				pos=117;
			pos++;
			FechaValida=1;
			UserValido=1;
			ServidorValido=1;
		}
	}

	fclose(archivoTXT);
	consola_administracion();
}

void consola_administracion(void)
{
	char op='0', Login[20], Mes[10], Dia[8], Hora[8], Minutos[8], Segundos[8];
	int n, i, Op;
	struct Log Log;

	clrscr();

	while(op!='5')
	{
		clrscr();
		printf("\n\nCONSOLA DE ADMINISTRACION DE LOGS(Lista con las fechas de los Logs)\n\n");
		printf("\n1. Numero de Logs.");
		printf("\n2. Listar los Logs.");
		printf("\n3. Mostrar si un usuario se a logueado.");
		printf("\n4. Mostrar un Log en una fecha y hora especifica.");
		printf("\n5. Salir.");
		printf("\nDigite su opcion: ");
		op=getch();
		clrscr();
		n=long_lista(fecha);
		switch(op)
		{
			case '1':       {
					printf("El numero de Logs es = %d.",n);
					printf("\n\n                     DIGITE UNA TECLA PARA TERMINAR...");
					getch();
					}
					break;
			case '2':       {
					i = 1;
					while(i<n)
					{
						Log=info_lista(fecha,i);
						if(((strcmp(Log.Accion,"Loginuser")==0)||(strcmp(Log.Accion,"Logoutuser")==0))&&(strcmp(Log.User,"")!=0))
							printf("* Log en la Posicion %d:\nFecha = %s %s %s:%s:%s.\nServidor = %s.\nID = %s.\nAccion = %s.\nUser = %s.\n",i,Log.Mes,Log.Dia,Log.Hora,Log.Min,Log.Seg,Log.Servidor,Log.ID,Log.Accion,Log.User);
						else
							printf("* Log en la Posicion %d:\nFecha = %s %s %s:%s:%s.\nServidor = %s.\nID = %s.\nAccion = %s.\n",i,Log.Mes,Log.Dia,Log.Hora,Log.Min,Log.Seg,Log.Servidor,Log.ID,Log.Accion);
						i++;
					}
					printf("\n\n                     DIGITE UNA TECLA PARA TERMINAR...");
					getch();
					}
					break;
			case '3':       {
					clrscr();
					printf("Escriba el Login del usuario: ");
					scanf("%s",Login);
					i = 1;
					while(i<n)
					{
						Log=info_lista(fecha,i);
						if((strcmp(Log.Accion,"Loginuser")==0)&&(strcmp(Log.User,Login)==0))
							printf("* Log en la Posicion %d:\nFecha = %s %s %s:%s:%s.\nServidor = %s.\nID = %s.\nAccion = %s.\nUser = %s.\n",i,Log.Mes,Log.Dia,Log.Hora,Log.Min,Log.Seg,Log.Servidor,Log.ID,Log.Accion,Log.User);
						i++;
					}
					printf("\n\n                     DIGITE UNA TECLA PARA TERMINAR...");
					getch();
					}
					break;
			case '4':       {
					clrscr();
					printf("Escriba la fecha y hora del Log:\n");
					printf("Escriba el numero del mes (1-12): ");
					scanf("%d",&Op);
					if(Op==1)
						strcpy(Mes,"Jan");
					if(Op==2)
						strcpy(Mes,"Feb");
					if(Op==3)
						strcpy(Mes,"Mar");
					if(Op==4)
						strcpy(Mes,"Apr");
					if(Op==5)
						strcpy(Mes,"May");
					if(Op==6)
						strcpy(Mes,"Jun");
					if(Op==7)
						strcpy(Mes,"Jul");
					if(Op==8)
						strcpy(Mes,"Aug");
					if(Op==9)
						strcpy(Mes,"Sep");
					if(Op==10)
						strcpy(Mes,"Oct");
					if(Op==11)
						strcpy(Mes,"Nov");
					if(Op==12)
						strcpy(Mes,"Dec");
					printf("Escriba el dia (01-31): ");
					scanf("%s",&Dia);
					printf("Escriba la hora (00-23): ");
					scanf("%s",&Hora);
					printf("Escriba los minutos (00-59): ");
					scanf("%s",&Minutos);
					printf("Escriba los segundos (00-59): ");
					scanf("%s",&Segundos);
					i = 1;
					while(i<n)
					{
						Log=info_lista(fecha,i);
						if((strcmp(Log.Mes,Mes)==0)&&(strcmp(Log.Dia,Dia)==0)&&(strcmp(Log.Hora,Hora)==0)&&(strcmp(Log.Min,Minutos)==0)&&(strcmp(Log.Seg,Segundos)==0))
							if(strcmp(Log.User,"")!=0)
								printf("* Log en la Posicion %d:\nFecha = %s %s %s:%s:%s.\nServidor = %s.\nID = %s.\nAccion = %s.\nUser = %s.\n",i,Log.Mes,Log.Dia,Log.Hora,Log.Min,Log.Seg,Log.Servidor,Log.ID,Log.Accion,Log.User);
							else
								printf("* Log en la Posicion %d:\nFecha = %s %s %s:%s:%s.\nServidor = %s.\nID = %s.\nAccion = %s.\nUser = Desconocido.\n",i,Log.Mes,Log.Dia,Log.Hora,Log.Min,Log.Seg,Log.Servidor,Log.ID,Log.Accion);
						i++;
					}
					printf("\n\n                     DIGITE UNA TECLA PARA TERMINAR...");
					getch();
					}
					break;
			case '5':       {
					salir();
					}
					break;
			default:        break;
		}
	}
}

void salir()
{

	clrscr();
	exit(0);

}