/*****************************************************************************
*
*   IMPLEMENTACION MODULO: lista_ap.c
*
*   LUGAR Y FECHA DE CREACION: Santiago de Cali, Diciembre de 2002.
*
*   Descripcion: TAD Lista: Implementado Sobre Apuntadores.
*
*   Requerimientos: Se requiere del Algoritmo de Control, un tipo de datos
*                   llamado elemento, para la parte info del nodo.
*
*****************************************************************************/
/*___________________________________________________________________________*

	 Archivos de interfaz de librerias estandar y otros modulos
*___________________________________________________________________________*/
#include <dos.h>
/*___________________________________________________________________________*

		    Implementacion de Funciones Publicas
*___________________________________________________________________________*/
lista inic_lista(void)
/* pre: true
   post: lst=< > */
{
	return(NULL);
}


lista ins_lista(lista lst, int pos, elemento elem)
/* pre: lst=<a1,a2,...,a(pos-1),a(pos),a(pos+1),...,an>; n>0; 1<=pos<=n; elem
   post: lst=<a1,a2,...,a(pos-1),elem,a(pos),a(pos+1),...,a(n+1)> */
{
	lista nuevo, aux;
	int longitud, cont;
	longitud=long_lista(lst);
	nuevo=(lista)malloc(sizeof(struct nodo));
	if ( nuevo==NULL )
	{
		clrscr();
		printf("ERROR NO HAY MEMORIA DISPONIBLE.");
		sound(300);
		sleep(1);
		nosound();
		sleep(3);
		clrscr();
		exit(0);
	}
	nuevo->info=elem;
	if ( pos==1 )
	{
		nuevo->sgte=lst;
		lst=nuevo;
	}
	else
	{
		aux=lst;
		cont=2;
		while ( cont!=pos )
		{
			aux=aux->sgte;
			cont++;
		}
		nuevo->sgte=aux->sgte;
		aux->sgte=nuevo;
	}
	if ( ( pos>longitud ) && ( pos!=1 ) )
	{
		clrscr();
		puts("ERROR POSICION INCORRECTA.");
		sound(300);
		sleep(1);
		nosound();
		sleep(2);
		clrscr();
	}
	return ( lst );
}

lista anx_lista(lista lst, elemento elem)
/* pre: lst=<a1,a2,...,an>; n>=0; elem
   post: lst=<a1,a2,...,an,elem>  */
{
	lista nuevo, aux;
	nuevo=(lista)malloc(sizeof(struct nodo));
	if ( nuevo==NULL )
	{
		clrscr();
		printf("ERROR NO HAY MEMORIA DISPONIBLE.");
		sound(300);
		sleep(1);
		nosound();
		sleep(3);
		clrscr();
		exit(0);
	}
	nuevo->info=elem;
	nuevo->sgte=NULL;
	if ( lst==NULL )
	{
		lst=nuevo;
	}
	else
	{
		aux=lst;
		while ( aux->sgte!=NULL )
		{
			aux=aux->sgte;
		}
		aux->sgte=nuevo;
	}
	return ( lst );
}

lista elim_lista(lista lst, int pos)
/* pre: lst=<a1,a2,...,a(pos),...,an>; n>0; 1<=pos<=n
   post: lst=<a1,a2,...,a(n-1)>  */
{
	lista aux1, aux2;
	int cont;
	if ( pos==1 )
	{
		aux2=lst;
		lst=lst->sgte;
		free(aux2);
	}
	else
	{
		cont=2;
		aux2=lst;
		while ( ( cont!=pos ) && ( aux2->sgte!=NULL ) )
		{
			aux2=aux2->sgte;
			cont++;
		}
		if ( cont==pos )
		{
			aux1=aux2->sgte;
			aux2->sgte=aux1->sgte;
			free(aux1);
		}
		else
		{
			clrscr();
			puts("ERROR POSICION INCORRECTA.");
			sound(300);
			sleep(1);
			nosound();
			sleep(3);
			clrscr();
		}
	}
	return ( lst );
}

elemento info_lista(lista lst, int pos)
/* pre: lst=<a1,a2,...,a(pos),...,an>; n>0; 1<=pos<=n
   post: a(pos)   */
{
	lista aux;
	int cont;
	if ( vacia_lista(lst) )
	{
		clrscr();
		printf("Error: lista vacia.");
		sound(300);
		sleep(1);
		nosound();
		sleep(3);
		clrscr();
		exit(0);
	}
	aux=lst;
	cont=1;
	while ( ( cont!=pos ) && ( aux->sgte!=NULL ) )
	{
		aux=aux->sgte;
		cont++;
	}
	if ( cont!=pos )
	{
		clrscr();
		puts("ERROR POSICION INCORRECTA.");
		sound(300);
		sleep(1);
		nosound();
		sleep(3);
		clrscr();
	}
	return ( aux->info );
}

int long_lista(lista lst)
/* pre: lst=<a1,a2,...,an>
   post: n        */
{
	lista aux;
	int cont;
	if ( lst==NULL )
	return ( 0 );
	else
	{
		aux=lst;
		cont=1;
		while	( aux->sgte!=NULL )
		{
			aux=aux->sgte;
			cont++;
		}
	}
	return ( cont );
}

/*___________________________________________________________________________*

		    Implementacion de Funciones Privadas
*___________________________________________________________________________*/
lista inv_lista(lista lst)
/* pre: lst=<a1,a2,...,an>; n>0; 1<=pos<=n
   post: lst=<an,a(n-1),...,a1>  */
{
	int cont, longitud;
	lista aux1, aux2;
	aux2=inic_lista();
	longitud=long_lista(lst);
	if ( !vacia_lista(lst) )
	{
		while ( longitud>0 )
		{
			cont=1;
			aux1=lst;
			while( cont<longitud )
			{
				aux1=aux1->sgte;
				cont++;
			}
			aux2=anx_lista(aux2, aux1->info);
			longitud--;
		}
	}
	return ( aux2 );
}

lista concatenar_lista(lista lst1, lista lst2)
/* pre: lst1=<a1,a2,...,an>; lst2=<b1,b2,...,bn>
   post: lst= <a1,a2,...,an,b1,b2,...,bn>  */
{
	int pos, longitud;
	lista aux;
	longitud=long_lista(lst2);
	pos=1;
	aux=lst1;
	while ( pos<=longitud )
	{
		aux=anx_lista(aux, info_lista(lst2, pos));
		pos++;
	}
	return ( aux );
}

lista cambiar_lista(lista lst, int pos, elemento elem)
/* pre: lst=<a1,a2,...,a(pos-1),a(pos),a(pos+1),...,an>; n>0; 1<=pos<=n; elem
   post: lst=<a1,a2,...,a(pos-1),elem,a(pos+1),...,a(n+1)> */
{
	lista nuevo, aux;
	int cont;
	nuevo=(lista)malloc(sizeof(struct nodo));
	if ( nuevo==NULL )
	{
		clrscr();
		printf("ERROR NO HAY MEMORIA DISPONIBLE.");
		sound(300);
		sleep(1);
		nosound();
		sleep(3);
		clrscr();
		exit(0);
	}
	nuevo->info=elem;
	nuevo->sgte=NULL;
	cont=1;
	aux=lst;
	while ( ( cont!=pos ) && ( aux->sgte!=NULL ) )
	{
		aux=aux->sgte;
		cont++;
	}
	if ( cont==pos )
	{
		aux->info=nuevo->info;
	}
	else
	{
		clrscr();
		puts("ERROR POSICION INCORRECTA.");
		sound(300);
		sleep(1);
		nosound();
		sleep(3);
		clrscr();
	}
	return ( lst );
}

lista intercambiar_lista(lista lst, int pospri, int posfin)
/* pre: lst=<a1,a2,...,a(pospri),...,a(posfin),...,an>; n>0
   post: lst=<a1,a2,...,a(posfin),...,a(pospri),...,an)> */
{
	lista pri, fin, aux;
	int cont=0;
	aux=(lista)malloc(sizeof(struct nodo));
	if ( aux==NULL )
	{
		clrscr();
		printf("ERROR NO HAY MEMORIA DISPONIBLE.");
		sound(300);
		sleep(1);
		nosound();
		sleep(3);
		clrscr();
		exit(0);
	}
	pri=lst;
	while ( cont<pospri )
	{
		pri=pri->sgte;
		cont++;
	}
	fin=pri;
	while ( cont<posfin )
	{
		fin=fin->sgte;
		cont++;
	}
	aux->info=fin->info;
	fin->info=pri->info;
	pri->info=aux->info;
	return ( lst );
}

lista dest_lista(lista lst)
/* pre: lst=<a1,a2,...,an>; n>0; 1<=pos<=n
   post: lst=< >  */
{
	lista aux1, aux2;
	while ( !vacia_lista(lst) )
	{
		aux1=lst;
		while ( aux1->sgte->sgte!=NULL )
		{
			aux1=aux1->sgte;
		}
		aux2=aux1;
		aux1=aux1->sgte;
		free(aux1);
		aux2->sgte=NULL;
		if ( lst->sgte==NULL )
		{
			aux2=lst;
			free(aux2);
			lst=NULL;
		}
	}
	return ( lst );
}

elemento pre_lista(lista lst, int pos)
/* pre: lst=<a1,a2,...,a(pos-1),a(pos),...,an>; n>0; 1<=pos<=n
   post: a(pos-1)   */
{
	int cont;
	lista aux;
	aux=lst;
	cont=2;
	while ( cont<pos )
	{
		aux=aux->sgte;
		cont++;
	}
	return ( aux->info );
}

elemento suc_lista(lista lst, int pos)
/* pre: lst=<a1,a2,...,a(pos),a(pos+1),...,an>; n>0; 1<=pos<=n
   post: a(pos+1)   */
{
	int cont;
	lista aux;
	aux=lst;
	cont=2;
	while ( cont<=pos )
	{
		aux=aux->sgte;
		cont++;
	}
	aux=aux->sgte;
	return ( aux->info );
}

elemento prim_lista(lista lst)
/* pre: lst=<a1,a2,...,an>; n>0; 1<=pos<=n
   post: a1   */
{
	return ( lst->info );
}

elemento ult_lista(lista lst)
/* pre: lst=<a1,a2,...,an>; n>0; 1<=pos<=n
   post: an   */
{
	lista aux;
	aux=lst;
	while ( aux->sgte!=NULL )
	{
		aux=aux->sgte;
	}
	return ( aux->info );
}

boolean vacia_lista(lista lst)
/* pre: lst TRUE
   post: si (lst==< >) => retorna (TRUE), sino => retorna (FALSE)   */
{
	if ( lst==NULL )
	{
		return ( TRUE );
	}
	else
	{
		return ( FALSE );
	}
}